Subject: Re: [PATCH] powerpc/fsl_pci: Fix pci stack build bug with FRAME_WARN

From: Scott Wood <[email-masked]>
Date: Thu, 22 Jan 2015 18:43:45 -0600

On Thu, 2015-01-22 at 18:20 -0600, Kim Phillips wrote:
> On Wed, 21 Jan 2015 21:02:27 -0600
> Scott Wood <[email-masked]> wrote:
> 
> > On Wed, 2015-01-21 at 20:48 -0600, Kim Phillips wrote:
> > > fake_pci_bus()' version is static, so it's not on the stack.
> > > 
> > > given that, maybe fsl_pcie_check_link()'s should be static too?
> > 
> > Oh.  How would you ensure that it's only called once at a time?  It
> > doesn't look like this is only called during early boot.
> > fsl_pcie_check_link() is called every time we do any config read through
> > the normal interface.  This is also a concern for the call to
> > early_read_config_dword().
> 
> I really don't know how that works: that code has been there since
> before linux was maintained in git.

Regardless, now that it's been noticed we should figure it out.
fsl_pcie_check_link() is using the early_*() functions in a context that
is not early and thus appears to be breaking the assumption that
fake_pci_bus() makes.

fsl_pcie_check_link() is fairly recent, FWIW.

> Below is the v2.

Please send as a standalone patch so I don't have to edit all the
discussion out of the commit message.

-Scott